/**
 * @class Apemansleep
 */

'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Apemansleep = function () {
  function Apemansleep() {
    var config = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, Apemansleep);

    var s = this;
    Object.assign(s, config);
    s._timers = {};
    s.sleep = s.sleep.bind(s);
    s.cancel = s.cancel.bind(s);
    s.cancelAll = s.cancelAll.bind(s);
  }

  /**
   * Sleep for duration.
   * @param {number} duration - Sleep milliseconds
   * @returns {Promise.<number>}
   */


  _createClass(Apemansleep, [{
    key: 'sleep',
    value: function sleep(duration) {
      var s = this;
      var timer = null;
      var promise = new Promise(function (resolve) {
        timer = setTimeout(function () {
          if (!s._timers) {
            return;
          }
          delete s._timers[timer];
          resolve(timer);
        }, duration);
      });
      promise.cancel = function () {
        return s.cancel(timer);
      };
      return promise;
    }

    /**
     * Cancel a sleep
     * @param {number} timer - Timeout
     * @returns {Promise.<number>}
     */

  }, {
    key: 'cancel',
    value: function cancel(timer) {
      var s = this;
      delete s._timers[timer];
      return Promise.resolve(timer);
    }

    /**
     * Cancel all sleeps
     * @returns {Promise.<number[]>}
     */

  }, {
    key: 'cancelAll',
    value: function cancelAll() {
      var s = this;
      var timers = Object.keys(s._timers);
      return Promise.all(timers.map(function (timer) {
        return s.cancel(timer);
      }));
    }
  }]);

  return Apemansleep;
}();

Object.assign(Apemansleep, {
  create: function create(config) {
    return new Apemansleep(config);
  }
});

module.exports = Apemansleep;